## mingw-w64-xa65-2.3.14-1.src.tar.zst

=== Makefile ===
# Unix gcc or DOS go32 cross-compiling gcc
#
CC = gcc
LD = gcc
# for testing. not to be used; build failures in misc/.
#CFLAGS = -O2 -W -Wall -pedantic -ansi
#CFLAGS = -O2 -g
CFLAGS = -O2 
LDFLAGS = -lc

# for DOS?
# CC = gcc-go32
# LD = gcc-go32
# CFLAGS = -W -Wall -pedantic 

# Other cc
#CC = cc
#CFLAGS =
#LD = ld

DESTDIR = /usr/local

BINDIR = $(DESTDIR)/bin
MANDIR = $(DESTDIR)/share/man/man1
DOCDIR = $(DESTDIR)/share/doc

MKDIR = mkdir -p
INSTALL = install

TESTS=ALL

all: killxa xa uncpk

killxa:
	rm -f xa

xa:
	(cd src && LD=${LD} CC="${CC} ${CFLAGS}" ${MAKE})

load:	
	(cd loader && CC="${CC} ${CFLAGS}" ${MAKE})

uncpk:
	(cd misc && CC="${CC} ${CFLAGS}" ${MAKE})

dos: clean
	(cd src && LD=gcc-go32 CC=gcc-go32 CFLAGS="-W -Wall -pedantic" ${MAKE})
	(cd misc && CC=gcc-go32 CFLAGS="-W -Wall -pedantic" ${MAKE})
	rm -f xa file65 ldo65 uncpk printcbm reloc65 mkrom.sh src/*.o

mingw: clean
	(cd src && LD=${LD} CC=${CC} CFLAGS="${CFLAGS}" LDFLAGS="" ${MAKE})
	(cd misc && LD=${LD} CC=${CC} CFLAGS="${CFLAGS}" LDFLAGS="" ${MAKE})
	
clean:
	(cd src && ${MAKE} clean)
	(cd loader && ${MAKE} clean)
	(cd misc && ${MAKE} mrproper)
	rm -f xa *.exe *.o65 *.s core

install: xa uncpk
	$(MKDIR) $(BINDIR)
	$(MKDIR) $(MANDIR)
	$(INSTALL) xa reloc65 ldo65 file65 printcbm uncpk $(BINDIR)
	$(INSTALL) man/file65.1 man/ldo65.1 man/printcbm.1 man/reloc65.1 man/uncpk.1 man/xa.1 $(MANDIR)
	#$(MKDIR) $(DOCDIR)/xa65

dist: clean
	cd .. ; tar cvf xa-2.3.14.tar xa-2.3.14 ; gzip xa-2.3.14.tar

test: xa uncpk
	cd tests && ./harness \
		-tests="$(TESTS)" \
		-make="$(MAKE)" -cc="$(CC)" -cflags="$(CFLAGS)"

=== misc/Makefile ===

XCBMLIB = ..

# -Wall -ansi et al. cause compile problems.
CFLAGS =  -O2

LIBS = #-lncurses -ltermcap -lm


all: ../mkrom.sh ../uncpk ../printcbm ../file65 ../reloc65 ../ldo65

../uncpk: uncpk.c
	${CC} ${CFLAGS} uncpk.c -o $(XCBMLIB)/uncpk

../printcbm: printcbm.c
	${CC} ${CFLAGS} printcbm.c -o $(XCBMLIB)/printcbm

../file65: file65.c
	${CC} ${CFLAGS} file65.c -o $(XCBMLIB)/file65

../ldo65: ldo65.c
	${CC} ${CFLAGS} ldo65.c -o $(XCBMLIB)/ldo65

../reloc65: reloc65.c
	${CC} ${CFLAGS} reloc65.c -o $(XCBMLIB)/reloc65

../mkrom.sh: mkrom.sh
	cp mkrom.sh ../mkrom.sh

lt1: lt1.a
	../xa -R -c -o lt1 lt1.a

lt2: lt2.a
	../xa -R -c -o lt2 lt2.a

lt: lt1 lt2
	../ldo65 -o lt lt1 lt2 

clean:
	rm -f *.o 

mrproper: clean
	rm -f ../uncpk ../printcbm ../file65 ../mkrom.sh ../reloc65 ../ldo65
	rm -f lt1 lt2 lt

=== tests/masmcom/Makefile ===
default:
	# compile with masm mode on.
	../../xa -M -o test.o test.s
	../hextool -cmp=okmasm < test.o
	# compile without
	../../xa -o test.o test.s
	../hextool -cmp=oknomasm < test.o

clean:
	rm -f *.o

=== PKGBUILD ===
#Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=xa65
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.3.14
pkgrel=1
pkgdesc="6502/65816 cross assembler"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64' 'clang32')
license=('GPL2')
url="http://www.floodgap.com/retrotech/xa/"
depends=()
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
source=("http://www.floodgap.com/retrotech/xa/dists/xa-${pkgver}.tar.gz"
        "0001-make-fix-predefined-variables.patch")
sha256sums=('1b9bbabddbd8d3b9410b852e50a128eea41e681339e6f76c3e8076fa5420f02e'
            'd84911cbc74b65c3892cf564e7a3ace88237e6ff9e2c867f8f2d8c54cd401d54')

prepare() {
  cd ${srcdir}/xa-${pkgver}
  patch -p1 -i "${srcdir}/0001-make-fix-predefined-variables.patch"
}

build() {
  cd ${srcdir}/xa-${pkgver}
  make ${MAKEFLAGS}
}

package() {
  cd ${srcdir}/xa-${pkgver}
  make DESTDIR=${pkgdir}${MINGW_PREFIX} install
  install -Dm644 ${srcdir}/xa-${pkgver}/README.1st ${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/README
}
